package eu.univento.core.commands;

import java.util.ArrayList;
import java.util.List;

import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import eu.univento.core.Core;
import eu.univento.core.api.AutoCommand;
import eu.univento.core.api.Messages;
import eu.univento.core.api.player.CustomPlayer;
import eu.univento.core.api.player.Perms.Ranks;

/**
 * lets player build
 * @author joethei
 * @version 1.0
 */
public class Build extends AutoCommand<Core>{
	
	/**
	 * player who can build
	 */
	private static ArrayList<CustomPlayer> players = new ArrayList<CustomPlayer>();
	
	/**
	 * @return player that can build
	 */
	public static ArrayList<CustomPlayer> getPlayers() {
		return players;
	}

	/**
	 * @param plugin main class
	 * @param command command to execute
	 * @param description describes the command
	 * @param aliases aliases of command
	 */
	public Build(Core plugin, String command, String description, String[] aliases) {
		super(plugin, command, description, aliases);
	}

	@Override
	public boolean execute(CommandSender sender, String label, String[] args) {
		if(sender instanceof Player) {
			CustomPlayer p = CustomPlayer.getPlayer(sender.getName());
			if(p.isAllowed(Ranks.Builder)) {
				if(players.contains(p)) {
					players.remove(p);
					p.sendMessage("cDu kannst nun nicht mehr bauen");
				}else {
					players.add(p);
					p.sendMessage("aDu kannst nun bauen");
				}
			}else {
				sender.sendMessage(Messages.NO_PERMS);
			}
		}else {
			sender.sendMessage(Messages.NOT_A_PLAYER);
		}
		return false;
	}

	@Override
	public List<String> tabComplete(CommandSender sender, String label, String[] args) {
		return null;
	}

}